'use strict'
const path = require('path')
const Config = require('./lib/merge-config-ex')
const config = new Config()

const get = (key, def) =>
    console.log(`${key} => ${JSON.stringify(config.get(key, def))}`)

config.file(path.join(__dirname, 'configs/config.yaml'))
console.log('')
console.log('configs/config.yaml')
console.log(JSON.stringify(config.get(), null, 4))
get('key')
get('key-with-sub')
get('key-with-not-exists-sub')
get('key-with-not-exists-sub-default', 'I\'m default')

config.set('new-key', 'new-value')
config.set('new-key-with-sub:sub', 'new-sub-value')
console.log('')
console.log('set value')
console.log(JSON.stringify(config.get(), null, 4))
get('new-key')
get('new-key-with-sub')
get('new-key-with-sub:sub')
get('new-key-with-sub.sub')

config.file(path.join(__dirname, 'configs/merge.cson'))
console.log('')
console.log('configs/merge.cson')
console.log(JSON.stringify(config.get(), null, 4))
get('merge')
get('merge-with-sub')
get('merge-with-sub:sub')
get('merge-with-sub.sub')

config.merge({ KEY1: 'value1', KEY2: 'value2' })
get('KEY1')
get('KEY2')
get('KEY3')

config.env(['TEMP', 'TMP'])
config.argv()
console.log('')
console.log('env and argv')
console.log(JSON.stringify(config.get(), null, 4))
